public inbox for libabigail@sourceware.org
 help / color / mirror / Atom feed
From: Dodji Seketeli <dodji@redhat.com>
To: Benjamin Kosnik <b.dekosnik@gmail.com>,
	Ben Woodard <woodard@redhat.com>, Chenxiong Qi <cqi@redhat.com>,
	Dodji Seketeli <dodji@redhat.com>,
	Giuliano Procida <gprocida@google.com>,
	Jan Engelhardt <jengelh@inai.de>, Jessica Yu <jeyu@kernel.org>,
	Jonathan Wakely <jwakely@redhat.com>,
	Mark Wielaard <mark@klomp.org>, Matthias Klose <doko@debian.org>,
	Matthias Maennich <maennich@google.com>,
	Ondrej Oprala <ondrej.oprala@gmail.com>,
	Roland McGrath <roland@hack.frob.com>,
	Sinny Kumari <skumari@redhat.com>,
	Slava Barinov <v.barinov@samsung.com>
Cc: libabigail@sourceware.org
Subject: [PATCH 3/9 v2] Add has-spdx-header.sh script
Date: Wed, 15 Jul 2020 17:13:05 +0200	[thread overview]
Message-ID: <87h7u8lsla.fsf@redhat.com> (raw)
In-Reply-To: <87zh80lt38.fsf@redhat.com> (Dodji Seketeli via Libabigail's message of "Wed, 15 Jul 2020 17:02:19 +0200")

Add a script to detect if a file has a SPDX header and what the
advertised license is.

	   * relicensing-scripts/has-spdx-header.sh: New script.

Signed-off-by: Dodji Seketeli <dodji@redhat.com>
Signed-off-by: Giuliano Procida <gprocida@google.com>
Signed-off-by: Matthias Maennich <maennich@google.com>
---
 relicensing-scripts/has-spdx-header.sh | 105 +++++++++++++++++++++++++++++++++
 1 file changed, 105 insertions(+)
 create mode 100755 relicensing-scripts/has-spdx-header.sh

diff --git a/relicensing-scripts/has-spdx-header.sh b/relicensing-scripts/has-spdx-header.sh
new file mode 100755
index 0000000..d4b7e08
--- /dev/null
+++ b/relicensing-scripts/has-spdx-header.sh
@@ -0,0 +1,105 @@
+#!/bin/sh
+# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
+# Author: Dodji Seketeli <dodji@redhat.com>
+
+file=
+prog=$0
+display_file_name=
+be_quiet=
+show_no_spdx=
+
+display_usage()
+{
+    echo "$prog: [options] file"
+    echo "  where options can be:"
+    echo "   -h|--help		display this help"
+    echo "   -f|--file		prefix output with file name"
+    echo "   -q|--quiet		emit no output if no license was found"
+    echo "   --show-no-spdx	show file name if it has no spdx header"
+}
+
+emit_output_no_license()
+{
+    if test x$show_no_spdx != x; then
+	echo $display_file_name
+    elif test x$be_quiet = x; then
+	if test "x$display_file_name" = x; then
+	    echo "NO-LICENSE"
+	else
+	    echo "$display_file_name: NO-LICENSE"
+	fi
+    fi
+
+    exit 1
+}
+
+emit_output_with_license()
+{
+    license=$1
+    if test x$show_no_spdx != x; then
+	:
+    elif test "x$display_file_name" = x; then
+	echo "$license"
+    else
+	echo "$display_file_name: $license"
+    fi
+    exit 0
+}
+
+main()
+{
+    license=$(head --lines=5 $file | sed -n -E "s/^.*(SPDX-License-Identifier:)[ 	]*([^*/]+).*$/\2/p")
+
+    if test "x$license" = x; then
+	emit_output_no_license
+    else
+	emit_output_with_license "$license"
+    fi
+}
+
+while test $# -ge 1
+do
+    case "$1" in
+	-h|--help)
+	    display_usage
+	    exit 0
+	    ;;
+
+	-f|--file)
+	    if test x$2 = x; then
+		>&2 display_usage
+		exit 1
+	    fi
+	    display_file_name=$2
+	    shift
+	    ;;
+
+	-q|--quiet)
+	    be_quiet=yes
+	    shift
+	    ;;
+
+	--show-no-spdx)
+	    if test x$2 = x; then
+		>&2 display_usage
+		exit 1
+	    fi
+	    show_no_spdx=yes
+	    display_file_name=$2
+	    shift
+	    ;;
+
+	*)
+	    break
+	    ;;
+    esac
+done
+
+if test $# -lt 1; then
+    >&2 display_usage
+    exit 1
+fi
+
+file=$1
+
+main
-- 
1.8.3.1


-- 
		Dodji


  parent reply	other threads:[~2020-07-15 15:13 UTC|newest]

Thread overview: 34+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-07-15 15:02 [PATCH 0/9 v2] Relicensing Libabigail to Apache 2.0 + LLVM Exception Dodji Seketeli
2020-07-15 15:11 ` [PATCH 1/9 v2] Replace individual license references with SPDX Identifiers Dodji Seketeli
2020-09-24 10:09   ` Jonathan Wakely
2020-09-24 10:14     ` Jonathan Wakely
2020-09-25  8:38     ` Dodji Seketeli
2020-09-25 10:06       ` Jonathan Wakely
2020-09-25 12:30         ` Dodji Seketeli
2020-07-15 15:11 ` [PATCH 2/9 v2] Add missing SPDX headers to source files not specifying any license Dodji Seketeli
2020-07-15 15:13 ` Dodji Seketeli [this message]
2020-07-16 10:26   ` [PATCH 3/9 v2] Add has-spdx-header.sh script Jonathan Wakely
2020-07-16 16:20     ` Dodji Seketeli
2020-07-15 15:13 ` [PATCH 4/9 v2] Add replace-spdx-license.sh script Dodji Seketeli
2020-07-16 10:27   ` Jonathan Wakely
2020-07-16 16:20     ` Dodji Seketeli
     [not found]   ` <CAGvU0Hnxmptf3irjhOV1SJcfXfQtas8+ttj3kvFyCWzCBFETPw@mail.gmail.com>
2020-09-03 14:47     ` Dodji Seketeli
2020-07-15 15:14 ` [PATCH 5/9 v2] Add helper files to perform the re-licensing Dodji Seketeli
     [not found]   ` <20200716103259.GZ4137376@redhat.com>
     [not found]     ` <874kq7jup5.fsf@redhat.com>
2020-09-24 10:12       ` Jonathan Wakely
2020-07-15 15:15 ` [PATCH 6/9 v2] Re-license the project to Apache v2 With LLVM Exception Dodji Seketeli
2020-07-16 10:33   ` Jonathan Wakely
2020-07-16 16:23     ` Dodji Seketeli
2020-07-15 15:16 ` [PATCH 7/9 v2] Add the LICENSE.txt file Dodji Seketeli
2020-07-15 15:17 ` [PATCH 8/9 v2] Delete COPYING* files Dodji Seketeli
2020-07-16 10:34   ` Jonathan Wakely
2020-07-16 16:23     ` Dodji Seketeli
2020-07-15 15:17 ` [PATCH 9/9 v2] Add a license-change-2020.txt file Dodji Seketeli
2020-07-16 10:35   ` Jonathan Wakely
2020-07-16 16:23     ` Dodji Seketeli
2020-07-16 16:01 ` [PATCH 0/9 v2] Relicensing Libabigail to Apache 2.0 + LLVM Exception Jessica Yu
2020-07-17 11:43   ` Dodji Seketeli
     [not found] <CGME20200903075248eucas1p2dcc11b3b1b24390a5da8bdc676bfd6b3@eucas1p2.samsung.com>
     [not found] ` <878sdruwk7.fsf@redhat.com>
2020-09-03  8:18   ` Please signoff libabigail relicensing. Was "[PATCH 0/9 v2] Relicensing Libabigail to Apache 2.0 + LLVM Exception" Vyacheslav Barinov
2020-09-03 14:40     ` Dodji Seketeli
2020-09-03  9:48   ` [PATCH 0/9 v2] Relicensing Libabigail to Apache 2.0 + LLVM Exception Jan Engelhardt
2020-09-03 14:39     ` Dodji Seketeli
     [not found]   ` <CAJxw1w=7C_MhOQ5E6dns9-7yD4qOcsBG52BtupCu3nv-L82Jiw@mail.gmail.com>
2020-09-03 14:39     ` Please signoff libabigail relicensing. Was "[PATCH 0/9 v2] Relicensing Libabigail to Apache 2.0 + LLVM Exception" Dodji Seketeli

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=87h7u8lsla.fsf@redhat.com \
    --to=dodji@redhat.com \
    --cc=b.dekosnik@gmail.com \
    --cc=cqi@redhat.com \
    --cc=doko@debian.org \
    --cc=gprocida@google.com \
    --cc=jengelh@inai.de \
    --cc=jeyu@kernel.org \
    --cc=jwakely@redhat.com \
    --cc=libabigail@sourceware.org \
    --cc=maennich@google.com \
    --cc=mark@klomp.org \
    --cc=ondrej.oprala@gmail.com \
    --cc=roland@hack.frob.com \
    --cc=skumari@redhat.com \
    --cc=v.barinov@samsung.com \
    --cc=woodard@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).